/***************************************************************************
                            CSSStyleSheet.java -  description
                             -------------------
    begin                : Sun Aug 26 09:45:02 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Aug 26 09:45:02 2001, using kdoc parser/custom Java conversion backend.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 The <code> CSSStyleSheet </code> interface is a concrete interface
 used to represent a CSS style sheet i.e. a style sheet whose
 content type is "text/css".

 
 @short 
 The <code> CSSStyleSheet </code> interface is a concrete interface
 used to represent a CSS style sheet i.
*/
public class CSSStyleSheet extends StyleSheet  {
	protected CSSStyleSheet(Class dummy){super((Class) null);}

	private native void newCSSStyleSheet();
	public CSSStyleSheet() {
		super((Class) null);
		newCSSStyleSheet();
	}
	private native void newCSSStyleSheet( CSSStyleSheet other);
	public CSSStyleSheet( CSSStyleSheet other) {
		super((Class) null);
		newCSSStyleSheet( other);
	}
	private native void newCSSStyleSheet( StyleSheet other);
	public CSSStyleSheet( StyleSheet other) {
		super((Class) null);
		newCSSStyleSheet( other);
	}
//	private native void newCSSStyleSheet( CSSStyleSheetImpl impl);
//	public CSSStyleSheet( CSSStyleSheetImpl impl) {
//		super((Class) null);
//		newCSSStyleSheet( impl);
//	}
	protected native void finalize() throws InternalError;

/** 
 If this style sheet comes from an <code> @import </code> rule,
 the <code> ownerRule </code> attribute will contain the <code>
 CSSImportRule </code> . In that case, the <code> ownerNode
 </code> attribute in the <code> StyleSheet </code> interface
 will be <code> null </code> . If the style sheet comes from an
 element or a processing instruction, the <code> ownerRule
 </code> attribute will be <code> null </code> and the <code>
 ownerNode </code> attribute will contain the <code> Node
 </code> .

     
*/
//	public native CSSRule ownerRule();

/** 
 The list of all CSS rules contained within the style sheet.
 This includes both <a
 href="http://www.w3.org/TR/REC-CSS2/syndata.html#q8"> rule sets
 </a> and <a
 href="http://www.w3.org/TR/REC-CSS2/syndata.html#at-rules">
 at-rules </a> .

     
*/
//	public native CSSRuleList cssRules();

/** 
 Used to insert a new rule into the style sheet. The new rule
 now becomes part of the cascade.

  INDEX_SIZE_ERR: Raised if the specified index is not a valid
 insertion point.

  NO_MODIFICATION_ALLOWED_ERR: Raised if this style sheet is
 readonly.

     
*/
	public native long insertRule( String rule, long index);

/** 
 Used to delete a rule from the style sheet.

  NO_MODIFICATION_ALLOWED_ERR: Raised if this style sheet is
 readonly.

     
*/
	public native void deleteRule( long index);
}
