/***************************************************************************
                            HTMLTableColElement.java -  description
                             -------------------
    begin                : Sun Aug 26 09:45:02 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Aug 26 09:45:02 2001, using kdoc parser/custom Java conversion backend.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 Regroups the <code> COL </code> and <code> COLGROUP </code>
 elements. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#edef-COL">
 COL element definition </a> in HTML 4.0.

 
 @short 
 Regroups the <code> COL </code> and <code> COLGROUP </code>
 elements.
*/
public class HTMLTableColElement extends HTMLElement  {
	protected HTMLTableColElement(Class dummy){super((Class) null);}

	private native void newHTMLTableColElement();
	public HTMLTableColElement() {
		super((Class) null);
		newHTMLTableColElement();
	}
	private native void newHTMLTableColElement( HTMLTableColElement other);
	public HTMLTableColElement( HTMLTableColElement other) {
		super((Class) null);
		newHTMLTableColElement( other);
	}
	private native void newHTMLTableColElement( DOMNode other);
	public HTMLTableColElement( DOMNode other) {
		super((Class) null);
		newHTMLTableColElement( other);
	}
	protected native void finalize() throws InternalError;

/** 
 Horizontal alignment of cell data in column. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-align-TD">
 align attribute definition </a> in HTML 4.0.

     
*/
	public native String align();

/** 
 see {@link align}
     
*/
	public native void setAlign( String arg1);

/** 
 Alignment character for cells in a column. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-char">
 char attribute definition </a> in HTML 4.0.

     
*/
	public native String ch();

/** 
 see {@link ch}
     
*/
	public native void setCh( String arg1);

/** 
 Offset of alignment character. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-charoff">
 charoff attribute definition </a> in HTML 4.0.

     
*/
	public native String chOff();

/** 
 see {@link chOff}
     
*/
	public native void setChOff( String arg1);

/** 
 Indicates the number of columns in a group or affected by a
 grouping. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-span-COL">
 span attribute definition </a> in HTML 4.0.

     
*/
	public native long span();

/** 
 see {@link span}
     
*/
	public native void setSpan( long arg1);

/** 
 Vertical alignment of cell data in column. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-valign">
 valign attribute definition </a> in HTML 4.0.

     
*/
	public native String vAlign();

/** 
 see {@link vAlign}
     
*/
	public native void setVAlign( String arg1);

/** 
 Default column width. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-width-COL">
 width attribute definition </a> in HTML 4.0.

     
*/
	public native String width();

/** 
 see {@link width}
     
*/
	public native void setWidth( String arg1);
//	private native void newHTMLTableColElement( HTMLTableColElementImpl impl);
//	public HTMLTableColElement( HTMLTableColElementImpl impl) {
//		super((Class) null);
//		newHTMLTableColElement( impl);
//	}
}
