/***************************************************************************
                            KGradientSelector.java -  description
                             -------------------
    begin                : Sun Aug 26 09:45:02 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Aug 26 09:45:02 2001, using kdoc parser/custom Java conversion backend.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 The KGradientSelector widget allows the user to choose
 from a one-dimensional range of colors which is given as a
 gradient between two colors provided by the programmer.
 
 See {@link KGradientSelectorSignals} for signals emitted by KGradientSelector.

 See {@link KGradientSelectorEventHandling} for event handlers to override in subclasses of KGradientSelector.

 @short 
 The KGradientSelector widget allows the user to choose
 from a one-dimensional range of colors which is given as a
 gradient between two colors provided by the programmer.
*/
public class KGradientSelector extends KSelector  {
	protected KGradientSelector(Class dummy){super((Class) null);}


/** 
 Constructs a horizontal color selector which
 contains a gradient between white and black.
   
*/
	private native void newKGradientSelector( QWidget parent, String name);
	public KGradientSelector( QWidget parent, String name) {
		super((Class) null);
		newKGradientSelector( parent, name);
	}
	private native void newKGradientSelector();
	public KGradientSelector() {
		super((Class) null);
		newKGradientSelector();
	}

/** 
 Constructs a colors selector with orientation o which
 contains a gradient between white and black.
   
*/
	private native void newKGradientSelector( int o, QWidget parent, String name);
	public KGradientSelector( int o, QWidget parent, String name) {
		super((Class) null);
		newKGradientSelector( o, parent, name);
	}
	public KGradientSelector( int o, QWidget parent) {
		this( o, parent, null);
	}
	private native void newKGradientSelector( int o);
	public KGradientSelector( int o) {
		super((Class) null);
		newKGradientSelector( o);
	}

/** 
 Destructs the widget.
   
*/
	protected native void finalize() throws InternalError;

/** 
 Sets the two colors which span the gradient.
   
*/
	public native void setColors( QColor col1, QColor col2);
	public native void setText( String t1, String t2);

}
