/***************************************************************************
                            KRadioAction.java -  description
                             -------------------
    begin                : Sun Aug 26 09:45:02 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Aug 26 09:45:02 2001, using kdoc parser/custom Java conversion backend.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 An action that operates like a radio button. At any given time
 only a single action from the group will be active.
 
 See {@link KRadioActionSignals} for signals emitted by KRadioAction.

 See {@link KRadioActionEventHandling} for event handlers to override in subclasses of KRadioAction.

 @short 
 An action that operates like a radio button.
*/
public class KRadioAction extends KToggleAction  {
	protected KRadioAction(Class dummy){super((Class) null);}


/** 
 Construct a radio action with text and potential keyboard
 accelerator but nothing else. Use this only if you really
 know what you are doing.

*/
	private native void newKRadioAction( String text, int accel, QObject parent, String name);
	public KRadioAction( String text, int accel, QObject parent, String name) {
		super((Class) null);
		newKRadioAction( text, accel, parent, name);
	}
	private native void newKRadioAction( String text);
	public KRadioAction( String text) {
		super((Class) null);
		newKRadioAction( text);
	}

/** 

*/
	private native void newKRadioAction( String text, int accel, QObject receiver, String slot, QObject parent, String name);
	public KRadioAction( String text, int accel, QObject receiver, String slot, QObject parent, String name) {
		super((Class) null);
		newKRadioAction( text, accel, receiver, slot, parent, name);
	}
	private native void newKRadioAction( String text, int accel, QObject receiver, String slot, QObject parent);
	public KRadioAction( String text, int accel, QObject receiver, String slot, QObject parent) {
		super((Class) null);
		newKRadioAction( text, accel, receiver, slot, parent);
	}

/** 

*/
	private native void newKRadioAction( String text, QIconSet pix, int accel, QObject parent, String name);
	public KRadioAction( String text, QIconSet pix, int accel, QObject parent, String name) {
		super((Class) null);
		newKRadioAction( text, pix, accel, parent, name);
	}
	private native void newKRadioAction( String text, QIconSet pix);
	public KRadioAction( String text, QIconSet pix) {
		super((Class) null);
		newKRadioAction( text, pix);
	}

/** 

*/
	private native void newKRadioAction( String text, String pix, int accel, QObject parent, String name);
	public KRadioAction( String text, String pix, int accel, QObject parent, String name) {
		super((Class) null);
		newKRadioAction( text, pix, accel, parent, name);
	}
	private native void newKRadioAction( String text, String pix);
	public KRadioAction( String text, String pix) {
		super((Class) null);
		newKRadioAction( text, pix);
	}

/** 

*/
	private native void newKRadioAction( String text, QIconSet pix, int accel, QObject receiver, String slot, QObject parent, String name);
	public KRadioAction( String text, QIconSet pix, int accel, QObject receiver, String slot, QObject parent, String name) {
		super((Class) null);
		newKRadioAction( text, pix, accel, receiver, slot, parent, name);
	}
	private native void newKRadioAction( String text, QIconSet pix, int accel, QObject receiver, String slot, QObject parent);
	public KRadioAction( String text, QIconSet pix, int accel, QObject receiver, String slot, QObject parent) {
		super((Class) null);
		newKRadioAction( text, pix, accel, receiver, slot, parent);
	}

/** 

*/
	private native void newKRadioAction( String text, String pix, int accel, QObject receiver, String slot, QObject parent, String name);
	public KRadioAction( String text, String pix, int accel, QObject receiver, String slot, QObject parent, String name) {
		super((Class) null);
		newKRadioAction( text, pix, accel, receiver, slot, parent, name);
	}
	private native void newKRadioAction( String text, String pix, int accel, QObject receiver, String slot, QObject parent);
	public KRadioAction( String text, String pix, int accel, QObject receiver, String slot, QObject parent) {
		super((Class) null);
		newKRadioAction( text, pix, accel, receiver, slot, parent);
	}

/** 

*/
	private native void newKRadioAction( QObject parent, String name);
	public KRadioAction( QObject parent, String name) {
		super((Class) null);
		newKRadioAction( parent, name);
	}
	private native void newKRadioAction();
	public KRadioAction() {
		super((Class) null);
		newKRadioAction();
	}
	protected native void slotActivated();
}
